'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

require('babel-polyfill');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

require('isomorphic-fetch');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var string = function string(values) {
  return _lodash2.default.map(values, function (value, key) {
    return encodeURIComponent(key) + '=' + encodeURIComponent(value);
  }).join('&');
};

var getHeader = function getHeader(req) {
  var headers = {
    'Content-Type': 'application/json'
  };

  if (req) {
    headers.cookie = req.get('cookie');
  }

  return {
    method: 'GET',
    headers: headers
  };
};

var postHeader = function postHeader(values, req) {
  var headers = {
    'Content-Type': 'application/json'
  };

  if (req) {
    headers.cookie = req.get('cookie');
  }

  return {
    method: 'POST',
    headers: headers,
    body: JSON.stringify(values)
  };
};

var deleteHeader = function deleteHeader(values, req) {
  var headers = {
    'Content-Type': 'application/json'
  };

  if (req) {
    headers.cookie = req.get('cookie');
  }

  return {
    method: 'DELETE',
    headers: headers,
    body: JSON.stringify(values)
  };
};

var ApiClient = function ApiClient(req) {
  _classCallCheck(this, ApiClient);

  this.fetchJSON = function () {
    var url = arguments.length <= 0 || arguments[0] === undefined ? '/' : arguments[0];
    var method = arguments.length <= 1 || arguments[1] === undefined ? 'GET' : arguments[1];
    var values = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];


    return new Promise(function (resolve, reject) {
      fetch(url + (method === 'GET' ? '?' + string(values) : ''), method === 'GET' ? getHeader(req) : method === 'POST' ? postHeader(values, req) : method === 'DELETE' ? deleteHeader(values, req) : '').then(function (res) {
        if (!res.ok) {
          res.json().then(function (json) {
            reject(json);
          }, function () {
            reject(res);
          });
        } else if (method === 'GET') {
          res.json().then(function (json) {
            resolve(json);
          }, function () {
            reject(res);
          });
        } else {
          resolve({});
        }
      }, function () {
        reject(res);
      });
    });
  };
};

exports.default = ApiClient;